#include "acdc.h"
// cumbia
#include <cumbiapool.h>
#include <cuserviceprovider.h>
#include <cumacros.h>
#include <quapps.h>
#include <qulabel.h>
#include <quwriter.h>
// cumbia

#include "ui_acdc.h"

Acdc::Acdc(CumbiaPool *cumbia_pool, QWidget *parent) :
    QWidget(parent)	/* ,    ui(new Ui::Acdc)	  // ## qumbiaprojectwizard: instantiated in constructor body */
{

// cumbia
    CuModuleLoader mloader(cumbia_pool, &m_ctrl_factory_pool, &m_log_impl);
    cu_pool = cumbia_pool;
    ui = new Ui::Acdc;
    ui->setupUi(this, cu_pool, m_ctrl_factory_pool);

    // mloader.modules() to get the list of loaded modules
    // cumbia
    connect(ui->cbShowUnits, SIGNAL(toggled(bool)), this, SLOT(m_show_units(bool)));
    m_show_units(false);

    connect(ui->bStopAll, SIGNAL(clicked()), this, SLOT(m_stop_all()));
}

Acdc::~Acdc()
{
    delete ui;
}

void Acdc::m_show_units(bool show) {
    foreach(QuLabel *l, findChildren<QuLabel *>())
        l->setDisplayUnitEnabled(show);
}

void Acdc::m_stop_all() {
    QStringList tgts;
    foreach(QGroupBox *gb, findChildren<QGroupBox *>(QRegularExpression("gbM\\d"))) {
        foreach(QuInputOutput *io, gb->findChildren<QuInputOutput *>()) {
            QString dev = io->source().section('/', 0, io->source().count('/') - 1);
            tgts << dev + "->Stop";
        }
    }
    if(tgts.size() > 0)
        tgts << "pos/dmrc/dmrc_pos.01->Stop";
    foreach(const QString &t, tgts) {
        printf("executing \e[1;32m%s\e[0m\n", qstoc(t));
        QuWriter *w = new QuWriter(this, cu_pool, m_ctrl_factory_pool);
        w->setAutoDestroy(true);
        w->setTarget(t);
        w->execute();
    }
}


